#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>

#ifndef M_PI
#define M_PI 3.14159265
#endif

static void cube() {
  glShadeModel(GL_FLAT);
  glNormal3f(0.0, 0.0, 1.0);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(-.5,-.5,.5);
  glVertex3f(.5,-.5,.5);
  glVertex3f(.5,.5,.5);
  glEnd();
  glNormal3f(0.0, 0.0, -1.0);
  glBegin(GL_QUADS);
  glVertex3f(.5,.5,-.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(-.5,.5,-.5);
  glEnd();
  glNormal3f(0.0, 1.0, 0.0);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(.5,.5,.5);
  glVertex3f(.5,.5,-.5);
  glVertex3f(-.5,.5,-.5);
  glEnd();
  glNormal3f(0.0, -1.0, 0.0);
  glBegin(GL_QUADS);
  glVertex3f(-.5,-.5,.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(.5,-.5,.5);
  glEnd();
  glNormal3f(1.0, 0.0, 0.0);
  glBegin(GL_QUADS);
  glVertex3f(.5,-.5,.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(.5,.5,-.5);
  glVertex3f(.5,.5,.5);
  glEnd();
  glNormal3f(-1.0, 0.0, 0.0);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(-.5,.5,-.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(-.5,-.5,.5);
  glEnd();
}

static GLfloat view_rotx = 20.0, view_roty = 30.0, view_rotz = 0.0;


static GLint cube1, cube2, cube3;
static GLfloat angle = 0.0;

static GLint cubes[27]; //27 cubes.

static const int loc[27][3] = {
   {0,0,0},
   
   {0,0,1},
   {0,0,-1},
   {0,1,0},
   {0,-1,0},
   {1,0,0},
   {-1,0,0},
   
   {1,1,1},
   {1,1,-1},
   {1,-1,1},
   {1,-1,-1},
   {-1,1,1},
   {-1,1,-1},
   {-1,-1,1},
   {-1,-1,-1},
   
   {0,1,1},
   {0,1,-1},
   {0,-1,1},
   {0,-1,-1},
   {-1,1,0},
   {-1,-1,0},
   {1,-1,0},
   {1,1,0},
   {-1,0,1},
   {-1,0,-1},
   {1,0,1},
   {1,0,-1},

};



static void
draw(void)
{
  int i;
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();
  glRotatef(view_rotx, 1.0, 0.0, 0.0);
  glRotatef(view_roty, 0.0, 1.0, 0.0);
  glRotatef(view_rotz, 0.0, 0.0, 1.0);
  
  for(i=0;i<27;i++) {
     glPushMatrix();
     glTranslatef(loc[i][0]*1.5,loc[i][1]*1.5,loc[i][2]*1.5);
     //glRotatef(angle, 0.0, 0.0, 1.0);
     glCallList(cubes[i]);
     glPopMatrix();
  }
  
 /* 
  glPushMatrix();
  //glTranslatef(-3.0, -2.0, 0.0);
  glRotatef(angle, 0.0, 0.0, 1.0);
  glCallList(cube1);
  glPopMatrix();

  glPushMatrix();
  glTranslatef(-3.0, -2.0, 0.0);
  glRotatef(angle, 0.0, 0.0, 1.0);
  glCallList(cube2);
  glPopMatrix();
  
  glPushMatrix();
  glTranslatef(3.0, -2.0, 0.0);
  glRotatef(angle, 0.0, 0.0, 1.0);
  glCallList(cube3);
  glPopMatrix();
  */
  glPopMatrix();

  glutSwapBuffers();

}

static void
init(void)
{
   int i;
  static GLfloat pos[4] =
  {5.0, 5.0, 10.0, 0.0};
  static GLfloat red[4] =
  {0.8, 0.1, 0.0, 1.0};
  static GLfloat green[4] =
  {0.0, 0.8, 0.2, 1.0};
  static GLfloat blue[4] =
  {0.2, 0.2, 1.0, 1.0};

  glLightfv(GL_LIGHT0, GL_POSITION, pos);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);

  for(i=0;i<9;i++) {
     cubes[i] = glGenLists(1);
     glNewList(cubes[i], GL_COMPILE);
     glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
     cube();
     glEndList();
  }
  
  for(;i<18;i++) {
     cubes[i] = glGenLists(1);
     glNewList(cubes[i], GL_COMPILE);
     glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
     cube();
     glEndList();
  }
  for(;i<27;i++) {
     cubes[i] = glGenLists(1);
     glNewList(cubes[i], GL_COMPILE);
     glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue);
     cube();
     glEndList();
  }

  glEnable(GL_NORMALIZE);
}

static void idle(void)
{
  angle += 2.0;
  glutPostRedisplay();
}

static void key(unsigned char k, int x, int y)
{
  switch (k) {
  case 'z':
    view_rotz += 5.0;
    break;
  case 'Z':
    view_rotz -= 5.0;
    break;
  case 27:  /* Escape */
    exit(0);
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

static void special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    view_rotx += 5.0;
    break;
  case GLUT_KEY_DOWN:
    view_rotx -= 5.0;
    break;
  case GLUT_KEY_LEFT:
    view_roty += 5.0;
    break;
  case GLUT_KEY_RIGHT:
    view_roty -= 5.0;
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}


void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);

  glutInitWindowPosition(0, 0);
  glutInitWindowSize(300, 300);
  glutCreateWindow("Rubix");
  init();

  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  glutMainLoop();
  return 0;         
}
