#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>

#ifndef M_PI
#define M_PI 3.14159265
#endif

static void cube(GLfloat *c1,GLfloat *c2,GLfloat *c3,GLfloat *c4,GLfloat *c5,GLfloat *c6) {
  glShadeModel(GL_FLAT);
  glScalef(2.0,2.0,2.0);
  
  glNormal3f(0.0, 0.0, 1.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c6);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(-.5,-.5,.5);
  glVertex3f(.5,-.5,.5);
  glVertex3f(.5,.5,.5);
  glEnd();
  glNormal3f(0.0, 0.0, -1.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c5);
  glBegin(GL_QUADS);
  glVertex3f(.5,.5,-.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(-.5,.5,-.5);
  glEnd();
  glNormal3f(0.0, 1.0, 0.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c1);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(.5,.5,.5);
  glVertex3f(.5,.5,-.5);
  glVertex3f(-.5,.5,-.5);
  glEnd();
  glNormal3f(0.0, -1.0, 0.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c2);
  glBegin(GL_QUADS);
  glVertex3f(-.5,-.5,.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(.5,-.5,.5);
  glEnd();
  glNormal3f(1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c4);
  glBegin(GL_QUADS);
  glVertex3f(.5,-.5,.5);
  glVertex3f(.5,-.5,-.5);
  glVertex3f(.5,.5,-.5);
  glVertex3f(.5,.5,.5);
  glEnd();
  glNormal3f(-1.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, c3);
  glBegin(GL_QUADS);
  glVertex3f(-.5,.5,.5);
  glVertex3f(-.5,.5,-.5);
  glVertex3f(-.5,-.5,-.5);
  glVertex3f(-.5,-.5,.5);
  glEnd();
}

static GLfloat view_rotx = 20.0, view_roty = 30.0, view_rotz = 0.0;

static GLint cube1, cube2, cube3;
static GLfloat angle = 0.0;

static GLint cubes; //27 cubes. beginning of lists
//static char  moves[] = "frtblrfhtblrfhrlhbrtlbfrltbhthrb";
static char  moves[] = "tblrfhtblrfhtblrfh";
static int l=0;

static int where[27];

static const int loc[27][3] = {
   {0,0,0}, //0
   
   {0,1,0},
   {0,-1,0},
   {-1,0,0},
   {1,0,0},
   {0,0,-1}, //5
   {0,0,1},
   
   {0,1,1}, //7
   {0,-1,1},
   {0,-1,-1}, //9
   {0,1,-1},
   {1,0,-1}, //11
   {1,0,1},
   {-1,0,1},
   {-1,0,-1}, //14
   {1,1,0},
   {1,-1,0},
   {-1,-1,0},
   {-1,1,0}, //18

   {1,1,1}, //19
   {-1,1,1},
   {-1,1,-1},
   {1,1,-1}, //22 
   {1,-1,-1},
   {1,-1,1},
   {-1,-1,1},
   {-1,-1,-1},
   /*
   {1,1,1}, //19
   {-1,1,1},
   {-1,1,-1},
   {1,1,-1}, //22 
   {1,-1,1},
   {-1,-1,1},
   {-1,-1,-1},
   {1,-1,-1},*/
};

static const int transl[6][27] = {
   {0,1,2,3,4,5,6,18,8,9,15,11,12,13,14,7,16,17,10,20,21,22,19,23,24,25,26}, //t
   {0,1,2,3,4,5,6,7,16,17,10,11,12,13,14,15,9,8,18,19,20,21,22,26,23,24,25}, //b
   {0,1,2,3,4,5,6,7,8,9,10,11,12,17,18,15,16,14,13,19,25,20,22,23,24,26,21}, //l
   {0,1,2,3,4,5,6,7,8,9,10,16,15,13,14,11,12,17,18,22,20,21,23,24,19,25,26}, //r
   {0,1,2,3,4,5,6,7,8,11,14,10,12,13,9,15,16,17,18,19,20,26,21,22,24,25,23}, //f
   {0,1,2,3,4,5,6,12,13,9,10,11,8,7,14,15,16,17,18,24,19,21,22,23,25,20,26}, //h
};

/*
int faces[6][9]= {
   {}, 
   {5,9,10,11,14,20,22,24,26}, //f
}*/


void updateloc(char face) {
   int i,j;
   int f;
   int nl[27];
   switch(face) {
	   case 't': f = 0; break;
	   case 'b': f = 1; break;
	   case 'l': f = 2; break;
	   case 'r': f = 3; break;
	   case 'f': f = 4; break;
	   case 'h': f = 5; break;
   }
   for(i=0;i<27;i++) 
   {
      for(j=0;j<27;j++)
	 if(where[j]==transl[f][i]) break;
      //nl[i] = where[transl[f][i]];
      nl[j]=i;
   }
   for(i=0;i<27;i++) 
      where[i]=nl[i];
};


void rotate(char f,float angle,int b) {
   int i;
   switch(f) {
	   case 't': 
		   if(loc[where[b]][1]==1)
		      glRotatef(angle,0.0,1.0,0.0);
		   break;
	   case 'b': 
		   if(loc[where[b]][1]==-1)
		      glRotatef(angle,0.0,-1.0,0.0);
		   break;
	   case 'l': 
		   if(loc[where[b]][0]==-1)
		      glRotatef(angle,-1.0,0.0,0.0);
		   break;
	   case 'r': 
		   if(loc[where[b]][0]==1)
		      glRotatef(angle,1.0,0.0,0.0);
		   break;
	   case 'f': 
		   if(loc[where[b]][2]==-1)
		      glRotatef(angle,0.0,0.0,-1.0);
		   break;
	   case 'h': 
		   if(loc[b][2]==1)
		      glRotatef(angle,0.0,0.0,1.0);
		   break;
   }
}


static void
draw(void)
{
  int i;
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();
  glRotatef(view_rotx, 1.0, 0.0, 0.0);
  glRotatef(view_roty, 0.0, 1.0, 0.0);
  glRotatef(view_rotz, 0.0, 0.0, 1.0);
  
  
  for(i=0;i<27;i++) {
     int j,k;
     glPushMatrix();
     for(k=0;k<27;k++)
	where[k]=k;
     for(k=0;k<l;k++)
	updateloc(moves[k]);

     rotate(moves[l],angle,i);
     for(j = l-1;j>=0;j--) {
	for(k=0;k<27;k++)
	   where[k]=k;
	for(k=0;k<j;k++)
	   updateloc(moves[k]);
	rotate(moves[j],90.0,i);
     }
     glTranslatef(loc[i][0]*2.7,loc[i][1]*2.7,loc[i][2]*2.7);
     //glRotatef(angle, 0.0, 0.0, 1.0);
     glCallList(cubes+i);
     glPopMatrix();
  }
  
  glPopMatrix();

  glutSwapBuffers();

}

static void
init(void)
{
   int i;
  static GLfloat pos[4] =
  {5.0, 5.0, 10.0, 0.0};
  static GLfloat red[4] =
  {0.8, 0.1, 0.0, 1.0};
  static GLfloat green[4] =
  {0.0, 0.8, 0.2, 1.0};
  static GLfloat blue[4] =
  {0.2, 0.2, 1.0, 1.0};
  static GLfloat cyan[4] =
  {0.9, 0.9, 0.1, 1.0};
  static GLfloat yellow[4] =
  {0.1, 0.9, 0.9, 1.0};
  static GLfloat rb[4] =
  {0.9, 0.1, 0.9, 1.0};
  static GLfloat grey[4] =
  {0.4, 0.4, 0.4, 1.0};

  for(i=0;i<27;i++) 
     where[i]=i;
  
  glLightfv(GL_LIGHT0, GL_POSITION, pos);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  
  i=0;
  
  cubes = glGenLists(27);
  //center
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,grey,grey,grey);
  glEndList();
  
  //faces
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,grey,grey,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,grey,grey,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,blue,grey,grey,grey);
  glEndList();

  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,cyan,grey,grey);
  glEndList();

  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,grey,yellow,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,grey,grey,rb);
  glEndList();
  
  //x-zero edges
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,grey,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,grey,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,grey,yellow,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,grey,yellow,grey);
  glEndList();
  
  //y-zero edges
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,cyan,yellow,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,grey,cyan,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,blue,grey,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,grey,blue,grey,yellow,grey);
  glEndList();

  //z-zero edges
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,cyan,grey,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,cyan,grey,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,blue,grey,grey,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,blue,grey,grey,grey);
  glEndList();
  //y+ corners
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,cyan,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,blue,grey,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,blue,grey,yellow,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(red,grey,grey,cyan,yellow,grey);
  glEndList();
  
  //y- corners
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,cyan,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,blue,grey,grey,rb);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,blue,grey,yellow,grey);
  glEndList();
  
  glNewList(cubes+i++, GL_COMPILE);
  cube(grey,green,grey,cyan,yellow,grey);
  glEndList();
  /*
  
  for(;i<27;i++) {
     glNewList(cubes+i, GL_COMPILE);
     cube(grey,grey,grey,grey,grey,grey);
     glEndList();
  }*/

  glEnable(GL_NORMALIZE);
}

static void idle(void)
{
  angle += 4.0;
  if(angle>=90.0) {angle=0.0;l++;}
  if(moves[l]=='\0') l--;
  glutPostRedisplay();
}

static void key(unsigned char k, int x, int y)
{
  switch (k) {
  case 'z':
    view_rotz += 5.0;
    break;
  case 'Z':
    view_rotz -= 5.0;
    break;
  case 27:  /* Escape */
    exit(0);
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

static void special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    view_rotx += 5.0;
    break;
  case GLUT_KEY_DOWN:
    view_rotx -= 5.0;
    break;
  case GLUT_KEY_LEFT:
    view_roty += 5.0;
    break;
  case GLUT_KEY_RIGHT:
    view_roty -= 5.0;
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}


void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);

  glutInitWindowPosition(0, 0);
  glutInitWindowSize(256, 256);
  glutCreateWindow("Rubix");
  init();

  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  glutMainLoop();
  return 0;         
}
